<?php
/***********************************************************
* Updated: Alex Estrada, PayJunction
* Date: August 23, 2010
* File: form.inc.php
* Description: Implementation of the Trinity Gateway Service API v1.2 in PHP.
* 

--Protecting your Website and Payment Applications from Man-In-The-Middle-Attacks--
Our API allows merchants and developers to connect to PayJunction via an encrypted SSL communications link. In order for your website or payment application to verify that your connection to PayJunction has not been intercepted, all code that connects to PayJunction must verify then authenticity of our SSL certificate by performing strict server certificate verification against PayJunction's root certificate authority. It has come to our attention that some merchants have disabled the SSL certificate verification for testing purpose; while the SSL connection remains secure, it is possible that an attacker could try to initiate a Man-In-The-Middle attack in an attempt to intercept your website's or applications connection to PayJunction.

Common Mistake: Anyone website or application that does not verify the authenticity of PayJunction's SSL certificate upon connecting to our QuickLink API.

Solution: Turn SSL verification on prior to connecting to PayJunction for transaction authorizations. In the event that your website is unable to verify the authenticity of PayJunction's root certificate, your website and/or application should not transmit any transaction information and should reject your customer's transactions. If you believe your application is unable to verify the authenticity of PayJunction's certificate, contact our support department.

--PayJunction Security Requirements and Best Practices for Merchants and Developers--
https://www.payjunction.com/trinity/support/view.action?knowledgeBase.knbKnowledgeBaseId=451

--Please note--
There is no warranty for the programs or example code provided in PayJunction's support center. The copyright holders and/or other parties provide the program "as is" without warranty of any kind, either expressed or implied, including, but not limited to, the implied warranties of merchantability and fitness for a particular purpose. The entire risk as to the quality and performance of the program is with you. Should the program prove defective, you assume the cost of all necessary servicing, repair or correction. It is the merchant's responsibility to ensure their systems meet the PCI requirements. PayJunction's Gateway Agreement have been updated to include the referenced "PayJunction Security Requirements and Best Practices for Merchants and Developers;" it is the merchant's responsibility to review this knowledge base on a regular basis for the security of the merchant's account and to protect cardholder data.

Please contact us if you have any questions.

With Kindest Regards,
The PayJunction Team
support@payjunction.com
***********************************************************/

$module = fetchDbConfig("PayJunction");

if($_GET['process']==1){

	## Required variables
	//$curl_exec		= "/usr/bin/curl -m 64 -d";
	$server			= "https://www.payjunction.com/quick_link";
	$request		= "";
	$response 		= array ();
	$is_approved		= false;
	$is_default_page	= true;
	 
		$post_array 	= array
		(
			"dc_logon"			=> $module['user'],
			
			"dc_version"			=> '1.2',
			"dc_password"			=> $module['pass'],
			"dc_transaction_type"		=> "AUTHORIZATION_CAPTURE",
			"dc_transaction_amount"		=> $basket['grandTotal'],
			"dc_first_name"			=> $_POST['dc_first_name'],
			"dc_last_name"			=> $_POST['dc_last_name'],
			"dc_number"			=> $_POST['dc_number'],
			"dc_expiration_month"		=> $_POST['dc_expiration_month'],
			"dc_expiration_year"		=> $_POST['dc_expiration_year'],
			"dc_verification_number"	=> $_POST['dc_verification_number'],
			"dc_address"			=> $_POST['dc_address'],
			"dc_city"			=> $_POST['dc_city'],
			"dc_state"			=> $_POST['dc_state'],
			"dc_zipcode"			=> $_POST['dc_zipcode'],
			"dc_country"			=> countryName($_POST['dc_country']),
			"dc_security"			=> 'AWZ|M|false|false|false'
		);
	
		## Setup the POST string to send to the PayJunction Server
		reset($post_array);
		while (list ($key, $val) = each($post_array)) 
		{
			$request .= $key . "=" . urlencode($val) . "&";
		}
	
		## Send the secure transaction request to PayJunction
		//$content = exec ("$curl_exec \"$request\" $server");
		
		// Use more secure curl_setop instead of exec
		$ch = curl_init($server); 
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 1);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);		
		curl_setopt($ch, CURLOPT_HEADER, 0); // set to 0 to eliminate header info from response
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, rtrim( $request, "& " )); // use HTTP POST to send form data
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 0);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); // Returns response data instead of TRUE(1)
		$content = curl_exec($ch); //execute post and get results
		$curl_errno = curl_errno($ch);
		$curl_error = curl_error($ch);
		curl_close ($ch);
	
			
		## Parse the response from PayJunction
		$content = array_values (split (chr (28), $content));
		while ($key_value = next ($content))
		{
			list ($key, $value) = split ("=", $key_value);
			$response[$key] = $value; 
		}

		## The result page.
		if ($response['dc_response_code'] == "00" || $response['dc_response_code'] == "85")
		{
			$is_approved = true;
		}
		$is_default_page = false;
	
	if ($is_approved){
			header("Location: confirmed.php");
			exit;
				
	} else {
			$fval="Error".$response['dc_response_message'];
			header("Location: confirmed.php?f=1");
			exit;
	}

}


$formTemplate = new XTemplate ("modules/gateway/PayJunction/form.tpl");

$formTemplate->assign("VAL_FIRST_NAME",$ccUserData[0]['firstName']);
$formTemplate->assign("VAL_LAST_NAME",$ccUserData[0]['lastName']);
$formTemplate->assign("VAL_EMAIL_ADDRESS",$ccUserData[0]['email']);
$formTemplate->assign("VAL_ADD_1",$ccUserData[0]['add_1']);
$formTemplate->assign("VAL_ADD_2",$ccUserData[0]['add_2']);
$formTemplate->assign("VAL_CITY",$ccUserData[0]['town']);
$formTemplate->assign("VAL_COUNTY",$ccUserData[0]['county']);
$formTemplate->assign("VAL_POST_CODE",$ccUserData[0]['postcode']);


$countries = $db->select("SELECT id, iso, printable_name FROM ".$glob['dbprefix']."CubeCart_iso_countries ORDER BY printable_name"); 
	
	for($i=0; $i<count($countries); $i++){
				
			
		if($countries[$i]['id'] == $ccUserData[0]['country']){
			$formTemplate->assign("COUNTRY_SELECTED","selected='selected'");
		} else {
			$formTemplate->assign("COUNTRY_SELECTED","");
		}
	
		$formTemplate->assign("VAL_COUNTRY_ISO",$countries[$i]['iso']);

		$countryName = "";
		$countryName = $countries[$i]['printable_name'];

		if(strlen($countryName)>20){

			$countryName = substr($countryName,0,20)."&hellip;";

		}

		$formTemplate->assign("VAL_COUNTRY_NAME",$countryName);
		$formTemplate->parse("form.repeat_countries");
	}
	
	$formTemplate->assign("LANG_CC_INFO_TITLE",$lang['module']['PayJunction']['cc_info_title']);
	$formTemplate->assign("LANG_FIRST_NAME",$lang['module']['PayJunction']['first_name']); 
	$formTemplate->assign("LANG_LAST_NAME",$lang['module']['PayJunction']['last_name']); 
	$formTemplate->assign("LANG_CARD_NUMBER",$lang['module']['PayJunction']['card_number']);
	$formTemplate->assign("LANG_EXPIRES",$lang['module']['PayJunction']['expires']);
	$formTemplate->assign("LANG_MMYYYY",$lang['module']['PayJunction']['mmyyyy']);
	$formTemplate->assign("LANG_SECURITY_CODE",$lang['module']['PayJunction']['security_code']);
	$formTemplate->assign("LANG_CUST_INFO_TITLE",$lang['module']['PayJunction']['customer_info']);
	$formTemplate->assign("LANG_ADDRESS",$lang['module']['PayJunction']['address']);
	$formTemplate->assign("LANG_CITY",$lang['module']['PayJunction']['city']);
	$formTemplate->assign("LANG_STATE",$lang['module']['PayJunction']['state']);
	$formTemplate->assign("LANG_ZIPCODE",$lang['module']['PayJunction']['zipcode']);
	$formTemplate->assign("LANG_COUNTRY",$lang['module']['PayJunction']['country']);


$formTemplate->parse("form");
$formTemplate = $formTemplate->text("form");
?>
